# coding: latin-1

class TestInput(object):
    # def __init__(self, test_daten, interact):
    #     self.td = test_daten
    #     self.interact = interact
    def clear_cache(self):
        from ebkus.db.dbapp import cache_clear_if_gt as clear
        clear(0)
    ## Das sind Abkrzungen, nicht wirklich ntig
    def set_config_vars(self, login=True, **kw):
        self.interact.set_config_vars(login=login, **kw)
    def set_today(self, date):
        self.interact.set_today(date)
    def login(self, user, passw):
        self.interact.login(user, passw)
    def logout(self):
        self.interact.logout()
    def submit(self, file, **kw):
        return self.interact.submit(self.td, file, **kw)
    ## Ende Abkrzungen

    def _mitarbeiter(self):
        """
        Admin, test, verw soll es immer geben fr Stelle A
        Ferner fr jede Stelle mit Code x:
        x_admin
        x_verw
        x1_bearb
        x2_bearb
        """
        self.submit('miteinf', 
            ben='test',
            stat='i',stz='A',
            benr='bearb',
            )
        self.submit('miteinf', 
            ben='verw',
            stat='i',stz='A',benr='verw',fax='Das ist seine Faxnummer!' )
        for stelle in ('A', 'B'):
            for i in range(1,3):
                self.submit('miteinf',
                    ben="{0}{1}_bearb".format(stelle.lower(), i),
                    stat='i',stz=stelle,
                    benr='bearb',
                    )
            self.submit('miteinf',
                ben="{0}_verw".format(stelle.lower()), 
                stat='i', stz=stelle, benr='verw')
            self.submit('miteinf',
                ben="{0}_admin".format(stelle.lower()), 
                stat='i', stz=stelle, benr='admin')
    def einrichten(self):
        self.login('Admin', 'Admin')
        # Stellen
        self._stellen()
        # Straenkatalog, erstmal ohne
        # Kreis, Einrichtungsnummern
        self._land_kreis_einrnr()
        # Fachstatistik
        self._fskonfig()
        # Mitarbeiter
        self._mitarbeiter()
        self.clear_cache()
        self.logout()
    
    def _stellen(self):
        # vorhandene Stellen deaktivieren
        from ebkus.app.ebapi import Code, CodeList
        stellen = self.td.stellen
        from ebkus.config import config as cfg
        # umbenennen des vordefinierten Stellenzeichens
        Code(kat_code='stzei', code='A').update({'name': stellen[0][1],
                                                 'code': stellen[0][0]})
        # weitere Stellen einfgen
        for i,stelle in enumerate(stellen[1:]):
            self.submit('codeeinf', katcode='stzei', code=stelle[0], name=stelle[1], sort=2+i)
    def _land_kreis_einrnr(self):
        # Stellenname in das dok-Feld des Landes eintragen, damit es bei dieser Stelle 
        # oben steht.
        from ebkus.app.ebapi import Code
        for stellenname, landname in self.td.laender:
            self.submit('updcode', codeid=Code(name=landname, kat_code='land')['id'],
                        dok="{0};".format(stellenname))
        # Kreise einrichten und Stellen in das dok-Feld eintragen
        for i, (stellenname, kreiscode, kreisname) in enumerate(self.td.kreise):
            self.submit('codeeinf', katcode='kr', code=kreiscode, name=kreisname,
                                    sort=i+1, dok="{0};".format(stellenname))
        # Einrichrungsnummer einrichten
        for i, (stellenname, einrichtungsnummer) in enumerate(self.td.einrichtungsnummern):
            self.submit('codeeinf', katcode='einrnr', code=einrichtungsnummer, 
                                    name="{0} (fr {1})".format(einrichtungsnummer, stellenname),
                                    sort=i+1, 
                                    dok="{0};".format(stellenname))
    def _fskonfig(self):
        self.submit('updfskonfig',
                    eleistungen_a=None,
                    joka1_a=None,
                    joka2_a=None,
                    joka3_l="Noch was?",
                    joka3_k='ja_ne_un',
                    #kat_a=None,
                    jokf5_a=None,
                    jokf6_k='gruende',
                    jokf6_l='Grnde fr die Hilfe',
                    jokf6_m=1,
                    jokf7_a=None,
                    jokf8_a=None,
                    )
    def eine_akte(self, t=None, zumitid='test'):
        if t is None:
            t = ('12.08.2015', '12.1.2016', '26.1.2016',  '12.2.2016', '12.4.2016')
        from ebkus.app.ebapi import str2date
        def aT(exp, msg='Error'):
            assert exp, msg
        def cd(mini, maxi):
            return self.td.choose_date(mini, maxi)
        t0 = t[0] 
        self.set_today(t0)
        # Akte einfhren
        self.login('test', 'test')
        form = self.submit('akteeinf', zubg=t0,
                           zumitid=zumitid, 
                           #ort='Berlin', str='Pflgerstr.', hsnr='4', 
                           mail='atms@gmx.de',
                           stzbg='A',
                           )
        akte_id = form['akid']
        fall_id = self.interact.get_letzter_fall_id(akte_id)
        #print 'AKTE_ID, FALL_ID, FILE', akte_id, fall_id, form['file']
        # # Bezugspersonen
        self.submit('perseinf', akid=akte_id)
        self.submit('perseinf', akid=akte_id)
        # # Einrichtungen
        self.submit('einreinf', akid=akte_id)
        self.submit('einreinf', akid=akte_id)
        self.logout()

        t1 = t[1] 
        # Abschluss
        self.set_today(t1)
        jahr = str2date(t1).year
        self.login('test', 'test')
        # Leistungen
        self.submit('leisteinf', fallid=fall_id, bg=cd(t0, t1))
        self.submit('leisteinf', fallid=fall_id, bg=cd(t0, t1))
        self.submit('leisteinf', fallid=fall_id, bg=cd(t0, t1))
        aT(self.interact.get_letzter_fall_id(akte_id) == fall_id)
        # Beratungskontakte
        self.submit('bkonteinf', bkfallid=[fall_id], k=cd(t0, t1))
        self.submit('bkonteinf', bkfallid=[fall_id], k=cd(t0, t1))
        self.submit('bkonteinf', bkfallid=[fall_id], k=cd(t0, t1))
        # Statistik
        self.submit('fseinf', fallid=fall_id, jahr=jahr)
        self.submit('jgh07einf', fallid=fall_id, jahr=jahr, e=t1)
        self.submit('zdaeinf', fallid=fall_id, zda=t1)
        aT(self.interact.get_letzter_fall_id(akte_id) == fall_id)
        self.logout()
        
        t2 = t[2] 
        # zda rckgngig
        self.set_today(t2)
        self.login('test', 'test')
        self.submit('zdareinf', fallid=fall_id)
        self.logout()
        t3 = t[3] 
        # # Erneuter Abschluss
        self.set_today(t3)
        self.login('test', 'test')
        self.submit('zdaeinf', fallid=fall_id, zda=t3)
        self.logout()

        t4 = t[4] 
        # # Wiederaufnahme 2 Monate spter
        self.set_today(t4)
        self.login('test', 'test')
        # akte_id = Fall(fall_id)['akte_id']
        self.submit('waufneinf', akid=akte_id, zubg=t4,
                    zumitid='test', 
                    )
        aT(self.interact.get_letzter_fall_id(akte_id) != fall_id)
        self.logout()
        return akte_id
        
    def neuaufnahme(self, zubg, user=None):
        t0 = zubg 
        self.set_today(t0)
        # Akte einfhren
        if user:
            self.login(user, user)
        form = self.submit('akteeinf', zubg=t0,
                           #zumitid='test', 
                           #ort='Berlin', str='Pflgerstr.', hsnr='4', 
                           #mail='atms@gmx.de',
                           #stzbg='A',
                           )
        akte_id = form['akid']
        fall_id = self.interact.get_letzter_fall_id(akte_id)
        #print 'AKTE_ID, FALL_ID, FILE', akte_id, fall_id, form['file']
        # Anmeldung
        if not self.config.ANMELDUNGSDATEN_OBLIGATORISCH:
            self.submit('anmeinf', fallid=fall_id)
        # # Bezugspersonen
        self.submit('perseinf', akid=akte_id)
        self.submit('perseinf', akid=akte_id)
        # # Einrichtungen
        self.submit('einreinf', akid=akte_id)
        self.submit('einreinf', akid=akte_id)
        if user:
            self.logout()
        return akte_id, fall_id

    def eintraege(self, akte_id, fall_id, beginn, ende, user=None):
        t0 = beginn
        t1 = ende
        def cd(mini, maxi):
            return self.td.choose_date(mini, maxi)
        from ebkus.app.ebapi import str2date
        def aT(exp, msg='Error'):
            assert exp, msg
        # Zeitpunkt der Eintraege
        self.set_today(t1)
        jahr = str2date(t1).year
        if user:
            self.login(user, user)
        # Leistungen
        self.submit('leisteinf', fallid=fall_id, bg=cd(t0, t1))
        self.submit('leisteinf', fallid=fall_id, bg=cd(t0, t1))
        self.submit('leisteinf', fallid=fall_id, bg=cd(t0, t1))
        aT(self.interact.get_letzter_fall_id(akte_id) == fall_id)
        # Beratungskontakte
        self.submit('bkonteinf', bkfallid=[fall_id], k=cd(t0, t1))
        self.submit('bkonteinf', bkfallid=[fall_id], k=cd(t0, t1))
        self.submit('bkonteinf', bkfallid=[fall_id], k=cd(t0, t1))
        # Statistik
        self.submit('fseinf', fallid=fall_id, jahr=jahr)
        self.submit('jgh07einf', fallid=fall_id, jahr=jahr, e=t1)
        if user:
            self.logout()

    def abschluss(self, akte_id, fall_id, beginn, ende, user=None):
        t0 = beginn
        t1 = ende
        from ebkus.app.ebapi import str2date
        def aT(exp, msg='Error'):
            assert exp, msg
        # Abschluss
        self.set_today(t1)
        jahr = str2date(t1).year
        if user:
            self.login(user, user)
        self.submit('zdaeinf', fallid=fall_id, zda=t1)
        aT(self.interact.get_letzter_fall_id(akte_id) == fall_id)
        if user:
            self.logout()


    def zdar(self, fall_id, datum):
        t2 = datum 
        # zda rckgngig
        self.set_today(t2)
        if user:
            self.login(user, user)
        self.submit('zdareinf', fallid=fall_id)
        if user:
            self.logout()

        t3 = t[3] 
        # # Erneuter Abschluss
        self.set_today(t3)
        if user:
            self.login(user, user)
        self.submit('zdaeinf', fallid=fall_id, zda=t3)
        if user:
            self.logout()

    def waufnahme(self, akte_id, wauf_beginn, user=None):
        t4 = wauf_beginn
        self.set_today(t4)
        if user:
            self.login(user, user)
        self.submit('waufneinf', akid=akte_id, zubg=t4)
        fall_id = self.interact.get_letzter_fall_id(akte_id)
        if user:
            self.logout()
        return fall_id
