# coding: latin-1
import string
from ebkus.app import Request
from ebkus.app.ebapi import today, ZustaendigkeitList, TabelleList
from ebkus.app_surface.menu_templates import *
from ebkus.app_surface.standard_templates import *
from ebkus.config import config

import ebkus.html.htmlgen as h
from ebkus.html.akte_share import akte_share

class menu(Request.Request, akte_share):
    permissions = Request.MENU_PERM

    def get_abmelden_pw(self):
        return h.FieldsetInputTable(
            daten=[[h.Button(value='Abmelden',
                             onClick="go_to_url('logout')",
                             tip="Logout",
                             ),
                    h.Button(value='Passwort ndern',
                             onClick="go_to_url('pwchange')",
                             tip="Passwort ndern",
                             ),
                    ]]
            )
    def _hauptmenu_klienten(self):
        logo_mitarbeiter_uhr = h.Table(
            rows=(
            h.Tr(cells=(h.String(string=("%(vn)s, %(na)s (%(ben)s, %(benr__name)s)<br />%%s" %
                                         self.mitarbeiter) % config.INSTANCE_TITLE,
                                 class_='normaltext',
                                 align='left',
                                 ),
                              h.Icon(href="/ebkus/%s/index.html" % config.INSTANCE_NAME,
                                     icon="/ebkus/ebkus_icons/ebkus_logo.gif",
                                     tip='Zur Zugangsseite und dem Handbuch',
                                     align='center',
                                     n_col=2),
                              h.String(string='<div id="Uhr">&nbsp;</div>',
                                       class_='normaltext',
                                       align="right",
                                       ),
                              ),
                       ),
                  
            ),
            )
        if config.ERINNERN_NACH_WOCHEN_OHNE_KONTAKT:
            lange_ohne_kontakt = self.laufende_beratungen_lange_ohne_kontakt(
                                                 stelle=self.stelle,
                                                 mitarbeiter=(self.mitarbeiter['benr__code'] == 'bearb' and self.mitarbeiter or None),
                                                 erledigt='nicht erledigt')
        gruppenmenu = h.FieldsetInputTable(
            daten=[[h.Button(value='Gruppenmen',
                             onClick="go_to_url('menugruppe')",
                             tip="Zum Gruppenmen",
                             ),
                    config.FALLUNABHAENGIGE_AKTIVITAETEN_BS and
                    h.Button(value='Fallunabh. Aktivitten',
                             onClick="go_to_url('fua')",
                             tip="Zu den fallunabhngigen Aktivitten",
                             class_='buttonbig',
                             ) or None,
                    ],
                   [config.ERINNERN_NACH_WOCHEN_OHNE_KONTAKT and
                    h.Button(value='Mehr als %s Wochen ohne Kontakt: %s' % (config.ERINNERN_NACH_WOCHEN_OHNE_KONTAKT,
                                                                            len(lange_ohne_kontakt)),
                             onClick="go_to_url('abfr2')",
                             tip="Zu den betreffenden Fllen",
                             class_='buttonhuge',
                             align='center',
                             n_col=2,
                             ) or None,
                    ],
                   ]
            )

        auswertungen = h.FieldsetFormInputTable(
            legend='Auswertungen',
            daten=[[h.String(string='&nbsp;'*13,
                             class_='labeltext'),
                    h.DropdownMenu(name='Auswertungen',
                                   url_name_pairs=self.url_name_pairs_for_auswertungen(),
                                   ),
                    ]]
            )

        klient = h.FieldsetFormInputTable(
            action='klkarte',
            name='klkarteform',
            method='post',
            legend='Klientenauswahl', 
            daten=[
                # [h.TextItem(name="klfilter",
                #             #id="klientenauswahl_filter",
                #             label="Filter:",
                #             onChange="FilterSelectList('klientenauswahl', 'klfilter')",
                #             n_col=6,
                #             ),
                #     ],
                   [h.SelectItem(name='fallid',
                                 size="18",
                                 class_="listbox280",
                                 #class_="listbox310",
                                 tip="Alle Flle, fr die Sie Zugriffsrechte haben. "
                                 "Zur Auswahl beliebige Zeichenfolge aus dem "
                                 "Meneintrag eintippen.",
                                 options=self.for_klienten(empty_option=True),
                                 n_col=6,
                                 nolabel=True,
                                 id="klientenauswahl",
                                 ),
                    ],
                   [h.RadioItem(label='Klientenkarte',
                                name='file',
                                value='klkarte',
                                checked=True,
                                tip='Klientenkarte fr ausgewhlten Klienten ansehen',
                                ),
                    h.RadioItem(label='Klientendokumente',
                                name='file',
                                value='kldok',
                                tip='Dokumente fr ausgewhlten Klienten ansehen',
                                ),
                    h.RadioItem(label='Aktenvorblatt',
                                name='file',
                                value='vorblattpdf',
                                tip='Aktenvorblatt fr ausgewhlten Klienten ansehen',
                                ),
                    ],
                   [h.String(string='Fachstatistik:',
                             class_='labeltext',
                             n_col=2,
                             ),
                    h.RadioItem(label='Neu',
                                name='file',
                                value='fsneu',
                                tip='Fachstatistik fr ausgewhlten Fall neu anlegen',
                                ),
                    h.RadioItem(label='ndern',
                                name='file',
                                value='updfsform',
                                tip='Fachstatistik fr ausgewhlten Fall ndern',
                                ),
                    ],
                   [(not config.KEINE_BUNDESSTATISTIK) and h.RadioItem(label='Bundesstatistik',
                                name='file',
                                value='updjghform', # wird in klientenkarte.py differenziert ausgewertet
                                tip='Bundesstatistik fr ausgewhlten Fall bearbeiten',
                                ) or None,
                    h.RadioItem(label='Fachstatistik',
                                name='file',
                                value='updfsform', # wird in klientenkarte.py differenziert ausgewertet
                                tip='Fachstatistik fr ausgewhlten Fall bearbeiten',
                                ),
                    h.DummyItem(),
                    ],
                   [h.DummyItem(n_col=6)],
                   [h.Button(value='Ok',
                             type='submit',
                             n_col=3,
                             ),
                    h.Button(value='Neuaufnahme',
                             type='button',
                             onClick="go_to_url('akteneu')",
                             n_col=3,
                             ),
                    #h.DummyItem(n_col=2),
                    ],
                   ],
            )

        res = h.Page(
            title='Hauptmen',
            help="das-hauptmen",
            onload="window.setTimeout('ZeitAnzeigen()',0)",
            rows=(logo_mitarbeiter_uhr,
                  h.Pair(left=(gruppenmenu,
                               auswertungen,
                               self.get_suche(),
                               self.get_abmelden_pw(),
                               ),
                         right=(klient,
                                ),
                         ),
                  ),
            )
        return res.display()
            


    def _hauptmenu_admin(self):
        allgemeine_konfiguration = h.FieldsetInputTable(
            legend='Einstellungen',
            daten=[[h.Button(value='Bearbeiten',
                             onClick="go_to_url('konfigausw')",
                             tip="Einstellungen (allgemeine Konfiguration) bearbeiten",
                             ),
                    ]],
            )
        mitarbeiter = h.FieldsetInputTable(
            legend='Mitarbeiter',
            daten=[[h.Button(value='Bearbeiten',
                             onClick="go_to_url('mitausw')",
                             tip="Merkmale von Mitarbeitern bearbeiten",
                             ),
                    h.Button(value='Neu',
                             onClick="go_to_url('mitneu')",
                             tip="Neuen Mitarbeiter eintragen",
                             ),
                    ]],
            )
        gruppen = h.FieldsetInputTable(
            legend='Gruppen',
            daten=[[h.DummyItem(), # zum Zentrieren
                    h.DropdownMenu(name='Lschen',
                                   tip='',
                                   url_name_pairs=(
                            ("rmgruppenf", ("Lschen wg. Fehler",
                                            "Es knnen nur Gruppen ohne Teilnehmer "
                                            "und ohne Endedatum gelscht werden.")),
                            ("rmgruppen", ("Lschen wg. Datenschutz",
                                           "Lschen nur mglich nach Ablauf der Lschfrist")),
                            ),
                                   ),
                    h.DummyItem(),
                    ]],
            )
        from ebkus.html.akten_loeschen import get_akten_loeschen_menu
        akten = h.FieldsetInputTable(
            legend='Akten',
            daten=[[h.Button(value='Sperren/Entsperren',
                             onClick="go_to_url('spakten')",
                             tip="Sperren und Entsperren von Akten",
                             class_="buttonbig",
                             ) if config.SPERRFRIST >= 0 else None,
                    h.Button(value='Altdaten importieren',
                             onClick="go_to_url('altimport')",
                             tip="Importieren von Klientendaten aus frheren Systemen",
                             class_="buttonbig",
                             ),
                    get_akten_loeschen_menu(),
                    ],
                   ],
            )
        if config.KEINE_BUNDESSTATISTIK:
            bundesstatistik = None
        else:
            bundesstatistik = h.FieldsetInputTable(
                legend='Bundesstatistik',
                daten=[[h.Button(value='Adressen auerhalb',
                                 onClick="go_to_url('jgh_wohnt_ausserhalb_check')",
                                 tip="Konfiguration von 'wohnt_nicht_ausserhalb' berprfen",
                                 class_="buttonbig",
                                 ),
                        h.Button(value='Exportieren',
                                 onClick="go_to_url('jghexportform')",
                                 tip="Bundesstatistikdatenstze im amtlichen Format erstellen",
                                 ),
                        ]],
                )
        fachstatistik = h.FieldsetInputTable(
            legend='Fachstatistik',
            daten=[[h.Button(value='Konfigurieren',
                             onClick="go_to_url('fskonfig')",
                             tip="Fachstatistik konfigurieren",
                             ),
                    ]],
            )
        # Tabellen, die Kategorien verwenden
        klassen = [t['klasse'] for t in
                   TabelleList(where='feld.kat_id IS NOT NULL',
                               join=[('feld', 'tabelle.id=feld.tab_id')]).sorted('klasse')]

        url_name_pairs = [("codelist?tbl=Alle", "Alle Tabellen"),]
        for k in klassen:
            url_name_pairs.append(("codelist?tbl=%s" % (k,), k))
        tip = "Merkmalskataloge der gewhlten Tabelle bearbeiten"
        merkmalskataloge = h.FieldsetFormInputTable(
            legend='Merkmalskataloge bearbeiten',
            daten=[[
                    h.DropdownMenu(name='Tabelle auswhlen',
                                   tip=tip,
                                   align="center",
                                   button_class="buttonbig",
                                   url_name_pairs=url_name_pairs),
                    ]],
            )
        strassenkatalog = h.FieldsetInputTable(
            legend='Straenkatalog',
            daten=[[h.Button(value='Importieren',
                             onClick="go_to_url('strkatimport')",
                             tip="Straenkatalog aus einer CSV-Datei importieren",
                             ),
                    h.Button(value='Exportieren',
                             onClick="go_to_url('strkatexport')",
                             tip="Straenkatalog als CSV-Datei exportieren",
                             ),
                    ]],
            )

        if config.SQL_ABFRAGE:
            sql_abfrage = h.FieldsetInputTable(
                legend='SQL Abfragen',
                daten=[[h.Button(value='Abfragen',
                                 onClick="go_to_url('sql_abfrage')",
                                 tip="Ergebnis einer SQL-Abfrage als CSV-Datei herunterladen",
                                 ),
                        ]],
                )
        else:
            sql_abfrage = None
        from ebkus.app.protocol import is_on
        if is_on():
            from ebkus.app.protocol import get_protocol_limit
            grenze = get_protocol_limit()
            protokoll = h.FieldsetFormInputTable(
                legend='Protokoll',
                name="fuellgrenze",
                action="admin_protocol",
                method="post",
                hidden = (('auswahl', 'pgrenze'),
                          ),
                daten=[[h.Button(value='Archivieren',
                                 onClick="go_to_url('admin_protocol?auswahl=archiv')",
                                 tip="Protokolldatenstze archivieren",
                                 ),
                        h.DummyItem(),
                        h.TextItem(label='Fllgrenze',
                                   tip="Max. Gre der Protokolltabelle vor automatischer Archivierung",
                                   name='grenze',
                                   value=grenze,
                                   maxlength=9,
                                   class_='textbox52',
                                   ),
                        h.Button(value='Speichern',
                                 type='submit',
                                 tip="Fllgrenze speichern",
                                 ),
                        ]],
                )
        else:
            protokoll = None

        if config.KEINE_BUNDESSTATISTIK:
            rows = (self.get_abmelden_pw(),
                  h.Pair(left=mitarbeiter,
                         right=allgemeine_konfiguration,
                         ),
                  h.Pair(left=merkmalskataloge,
                         right=fachstatistik,
                         ),
                  h.Pair(left=akten,
                         right=gruppen,
                         ),
                  h.Pair(left=sql_abfrage,
                         right=strassenkatalog,
                         ),
                  protokoll,
                  )
        else:
            rows = (self.get_abmelden_pw(),
                  h.Pair(left=mitarbeiter,
                         right=allgemeine_konfiguration,
                         ),
                  h.Pair(left=bundesstatistik,
                         right=fachstatistik,
                         ),
                  h.Pair(left=merkmalskataloge,
                         right=strassenkatalog,
                         ),
                  h.Pair(left=akten,
                         right=gruppen,
                         ),
                  h.Pair(left=sql_abfrage,
                         right=None,
                         ),
                  protokoll,
                  )

        res = h.Page(
            title='Administratorhauptmen',
            help="das-hauptmen",
            breadcrumbs = ((),),
            rows=rows,
            )
        return res.display()

    def processForm(self, REQUEST, RESPONSE):
        #if True: return self._hauptmenu_klienten()
        mitarbeiterliste = self.getMitarbeiterliste()
        user = self.user
        stelle = self.stelle
        mitarbeiter = self.mitarbeiter
        # damit das logo auf dem Hauptmen auf die Eingangsseite der Instanz
        # verlinken kann
        mitarbeiter['index_url'] = "/ebkus/%s/index.html" % config.INSTANCE_NAME
        res = []
        if mitarbeiter['benr__code'] == 'bearb':
            return self._hauptmenu_klienten()
        elif mitarbeiter['benr__code'] == 'verw':
            return self._hauptmenu_klienten()
            # Admin soll keine Klientennamen erhalten, er braucht nur das Admin-Menu.
        elif mitarbeiter['benr__code'] == 'admin':
            return self._hauptmenu_admin()
        elif mitarbeiter['benr__code'] == 'protokol':
            res2 = []
            meldung = {'titel':'Gesicherter Bereich!',
                      'legende':'Achtung!',
                      'zeile1':'Sie betreten einen Hochsicherheitsbereich',
                      'zeile2':'Sie werden zur Protokoll - Anmeldung weitergeleitet.','url':'login_formular'}
            res2.append(meldung_weiterleitung_t % meldung)
            return string.join(res2, '')
        return string.join(res, '')
        
        
        
        
        
        
        
        
