# coding: latin-1

"""
Wir.EB-Anbindung fr EBKuS.

siehe:
/home/atms/dev/ebkus/wir.eb/
  Anlage Dateiformat Statistikdaten 2019-02-14.pdf
  Anleitung Fallverlinkung 2019-10-30 EBKuS.pdf


klkarte wireb hinzufgen
   wireb (mit link und Hinweis auf manuell und Credentials)
         input feld
   action: klkarte
   file:   wirebeinf
klkarte wireb bearbeiten:
   wireb
   action: None
   file: None
klkarte wireb lschen
  action: klkarte
  file: removewireb
  submit or back  



wireb Bgen bearbeiten mit Link, 
  ffnet in anderem Tab, wireb bleibt unverdert
wireb erinnern
  immer dann prfen, wenn mehr als 6 Monate seit Anlage des Falles vergangen
  sind.
  Auerdem bei Abschluss des Falles, fall config.WIREB > 1
  Wenn keine 6 Monate vergangen sind, verbal nachfragen vor zda.
wireb JGH-Statistik hochladen (Button)
  wireb
  action: wireb
  file: jgh_upload
wireb JGH-Statistik erneut hochladen (Button)
  wireb
  action: wireb
  file: jgh_upload
wireb JGH-Statistik Lschen (Button)
  wireb
  action: wireb
  file: removejghwireb
wireb get Klientenkarte
  Link akid=

mit python < 2.7.13:

Traceback (most recent call last):
  File "/home/ebkus/ebkus_test/ebkus/demo_strkat_test/start.py", line 22, in <module>
    import ebkus.ebs
  File "/home/ebkus/ebkus_test/ebkus/lib/ebkus/ebs.py", line 13, in <module>
    bobo_application = EBKuS.EBKuS()
  File "/home/ebkus/ebkus_test/ebkus/lib/ebkus/app/EBKuS.py", line 28, in __init__
    self.classes = getClassesToBePublished()
  File "/home/ebkus/ebkus_test/ebkus/lib/ebkus/app/EBKuS.py", line 167, in getClassesToBePublished
    from ebkus.html.wireb import wireb
  File "/home/ebkus/ebkus_test/ebkus/lib/ebkus/html/wireb.py", line 51, in <module>
    import requests
  File "/home/ebkus/ebkus_test/ebkus/lib/requests/__init__.py", line 53, in <module>
    from .packages.urllib3.contrib import pyopenssl
  File "/home/ebkus/ebkus_test/ebkus/lib/requests/packages/urllib3/contrib/pyopenssl.py", line 70, in <module>
    ssl.PROTOCOL_SSLv3: OpenSSL.SSL.SSLv3_METHOD,
AttributeError: 'module' object has no attribute 'PROTOCOL_SSLv3'

daher konditional importieren, sonst startet EBKuS nicht.


"""
import sys
import urllib
import logging
from ebkus.app import Request
from ebkus.app.ebapi import Code, Akte, Fall, Wireb, MitarbeiterList, \
    Beratungskontakt, BeratungskontaktList, \
     today, setDate, cc, cn, bcode, check_int_not_empty, check_list, EE
from ebkus.app.ebapih import get_codes, make_option_list
from ebkus.config import config
import ebkus.html.htmlgen as h
from ebkus.html.akte_share import akte_share

import requests

class wireb(Request.Request):
    """Wir.EB-Anbindung"""
    permissions = Request.UPDATE_PERM
    def processForm(self, REQUEST, RESPONSE):
        fall_id = self.form.get('fallid')
        wireb_id = self.form.get('wirebid')
        file = self.form.get('file')
        if file == 'wirebeinf':
            if not fall_id:
                self.last_error_message = "Keine ID fr den Fall erhalten"
                return self.EBKuSError(REQUEST, RESPONSE)
            fall = Fall(fall_id)
            return self._process_wirebeinf(REQUEST, RESPONSE, fall)
        if not wireb_id:
            self.last_error_message = "Keine Wir.EB-Id erhalten"
            return self.EBKuSError(REQUEST, RESPONSE)
        wireb = Wireb(wireb_id)
        fall = wireb['fall']
        if file == 'removewireb':
            return self._process_removewireb(REQUEST, RESPONSE, wireb=wireb)
        if file == 'uploadjghwireb':
            op = self.form.get('op')
            if op:
                if 'laden' in op:
                    action = 1
                elif 'schen' in op:
                    action = 2
                else:
                    action = 'error'
            if not op or action == 'error':
                raise EE('Button.op der Form ist falsch: %s' % op)
            return self._process_uploadjghwireb(REQUEST, RESPONSE, wireb, action)
        if file == 'wireb_alle_bearbeitet':
            alle_bearbeitet = self.form.get('alle_bearbeitet')
            if alle_bearbeitet is None:
                alle_bearbeitet = cc('ja_nein', '2')
            from ebkus.app import ebupd
            ebupd.updwireb({'wirebid': wireb_id, 'alle_bearbeitet': alle_bearbeitet})
        return self._process(REQUEST, RESPONSE, wireb=wireb)

    def _process(self, REQUEST, RESPONSE, wireb):
        """Wir.EB-Seite, wenn Fallcodenummer bereits vorhanden ist.
        Wird von anderen Methoden am Ende aufgerufen.
        """
        fall = wireb['fall']
        akte = fall['akte']         
        url = WirebAPI(action='codetoid', return_='redirect', 
                  include_credentials=True,
                  wirebcode=wireb['fallcodenummer']).url()
        legendtext = "Wir.EB-Fallcodenummer und Link zu den Evaluationsbgen"
        wireb_fallcodenummer = h.FieldsetFormDataTable(
            legend='%s fr %s %s' % (legendtext, fall['akte__vn'], fall['akte__na']),
            name='wireb_alle_bearbeitet',
            action='wireb',
            method='post',
            hidden=(('wirebid', wireb['id']),
                    ('fallid', fall['id']),
                    ('file', 'wireb_alle_bearbeitet'),
                    ),
            headers=('Fallcodenummer bei Wir.EB', 'Link zu den Evaluationsbgen (Anmeldung erforderlich)', '', 'Alle Bgen ausgefllt'),
            daten = [[h.String(string='%s' % wireb['fallcodenummer'],
                               ),
                      h.Link(string="Evaluationsbgen bei Wir.EB bearbeiten",
                             url=url,
                             target='_blank',
                             tip="Anmeldung mit Benutzer: {} Passwort: {}" 
                             .format(config.WIREB_WEB_USER, config.WIREB_WEB_PASSWORD),
                             ),
                      h.CheckItem(label='',
                                  label_width='0%',
                                  align='center',
                                  name='alle_bearbeitet',
                                  value=cn('ja_nein', 'ja'),
                                  checked=wireb['alle_bearbeitet']==cn('ja_nein', 'ja'),
                                  onClick='submit()',
                                  )
                      ],
                     ],
            )
        wireb_jghstatistik = self.get_wireb_jghstatistik(wireb)
        erinnerung = None
        # Da die Anfrage bei Wir.EB lange dauert (mehrere Sekunden)
        # erst prfen, ob berhaupt schon 6 Monate vergangen sind.
        if wireb.getDate('fcbg').diff(today()) > 5:
            #print 'WIREB REMINDER...'
            res = self.reminder(wireb) 
            #print 'WIREB REMINDER:', res
            if res:
                erinnerung = h.FieldsetDataTable(
                    legend = 'Erinnerung',
                    daten = [[h.String(
                                string="Die Wir.EB-Bgen wurden seit ber sechs Monaten "
                                "nicht mehr bearbeitet und es gibt noch keinen "
                                "Berater-Abschlussbogen."),
                              ]]
                    )
        menu = h.FieldsetInputTable(daten=[[
            h.Button(value="Klientenkarte",
                     tip="Zurck zur Klientenkarte",
                     onClick="go_to_url('klkarte?akid=%(id)s')" % akte,
                     #class_='buttonbig',
                   ),]])
        res = h.Page(
            title="Wir.EB-Anbindung",
            breadcrumbs = (('Hauptmen', 'menu'),
                           ('Klientenkarte', 'klkarte?akid=%(akte_id)s' % fall),
                           ),
            rows=(menu,
                  wireb_fallcodenummer,
                  wireb_jghstatistik,
                  erinnerung,
                  )
            )
        return res.display()
        
    def get_wireb_jghstatistik(self, wireb):
        wireb_id = wireb['id']
        fall = wireb['fall']
        jgh = fall['jgh']
        legend="Jugendhilfestatistik nach Wir.EB hochladen"
        if jgh is None:
            return FieldsetInputTable(
                legend=legend,
                daten=[[h.String(string="Jugendhilfestatistik noch nicht erstellt",
                            class_='normaltext'),
                        ]]
                )
        #jgh_status = {noch nicht, hochgeladen, geloescht }
        if wireb['jghbgy'] is None:
            status = 'noch nicht'
        elif wireb['jghbgy'] == 0:
            status = 'geloescht'
        else:
            status = 'hochgeladen'
        res = h.FieldsetFormDataTable(
            name='jgh_upload',
            action='wireb',
            method='post',
            hidden=(('wirebid', wireb_id),
                    ('file', 'uploadjghwireb'),
                     ('jghid', jgh['id'])),
            legend=legend,
            headers=('Status',),
            daten=[[h.String(string='Hochgeladen am %s' % wireb.getDate('jghbg'),
                             n_col=2) 
                    if status == 'hochgeladen' else
                    h.String(string='Noch nicht hochgeladen',
                             n_col=1) 
                    if status == 'noch nicht' else
                    h.String(string='Gelscht',
                             tip='Hochgeladene Daten wurden bei Wir.EB wieder gelscht, z.B. '
                             'aus Grnden des Datenschutzes',
                             n_col=1) 
                    ],
                   [h.Button(name='op',
                             value='Erneut hochladen',
                             class_='buttonbig',
                             type='submit',
                             tip='Jetzt erneut hochladen, alte Daten werden berschrieben') 
                    if status == 'hochgeladen' else
                    h.Button(name='op',
                             value='Hochladen',
                             type='submit',
                             tip='Jetzt erstmalig hochladen')
                    if status == 'noch nicht' else
                    h.Button(name='op',
                             value='Erneut hochladen',
                             type='submit',
                             tip='Jetzt wieder hochladen'),
                    h.Button(name='op',
                             value='Lschen',
                             type='submit',
                             tip='Hochgeladene Daten werden bei Wir.EB gelscht')
                    if status == 'hochgeladen' else None,
                    ]]
                )
        return res
    def _process_uploadjghwireb(self, REQUEST, RESPONSE, wireb, action):
        jgh = wireb['fall__jgh']
        wdas = WirebDatensatz(jgh, 
                             WEBFallcodenummer=wireb['fallcodenummer'],
                             WEBActioncode=action)
        csv_datensatz = wdas.wireb_csv_header() + '\n'
        csv_datensatz += wdas.wireb_csv_datensatz() + '\n'
        api = WirebAPI(action=None, # nicht ntig fr csv()
                       verbose=False)
        try:
            res = api.csv(csv_datensatz)
        except Exception as exc:
            #t = sys.exc_info()[0]
            msg = ("Jugendhilfestatistik fr Fall %s bei Wir.EB konnte nicht %s werden."
                   % (wireb['fall__fn'], 
                      'hochgeladen' if action == 1 else 'gelscht',))
            #logging.exception(msg + "%s: %s", t, exc)
            logging.exception(msg)
            raise EE(msg + " %s" % str(exc))
        if res.status_code == 200:
            if action == 1:
                logging.info("Jugendhilfestatistik fr Fall %s zu Wir.EB hochgeladen" % wireb['fall__fn'])
            else:
                logging.info("Jugendhilfestatistik fr Fall %s bei Wir.EB gelscht" % wireb['fall__fn'])
        else:
            raise EE("Jugendhilfestatistik fr Fall %s bei Wir.EB konnte nicht hochgeladen werden: %s" % (wireb['fall__fn'], res.reason))
        assert res.status_code == 200, res.reason
        #print 'JGHBG VORHER:',wireb.getDate('jghbg')
        from ebkus.app import ebupd
        form = {'wirebid': wireb['id']}
        if action == 1:
            setDate(form, 'jghbg', today())
        else:
            form['jghbgy'] = '0'
        ebupd.updwireb(form)
        #print 'JGHBG NACHHER:', wireb.getDate('jghbg')
        return self._process(REQUEST, RESPONSE, wireb)

        
    def _process_wirebeinf(self, REQUEST, RESPONSE, fall):
        empty_wireb_config_vars = get_empty_wireb_config_vars()
        if empty_wireb_config_vars:
            raise EE("Konfiguration fr Wir.EB-Anbindung nicht vollstndig: {}"
                     .format(','.join(empty_wireb_config_vars)))
        wireb = Wireb()
        wireb.init(
            id=Wireb().getNewId(),
            fall_id=fall['id'],
            fallcodenummer=None,
           )
        wireb.setDate('fcbg', today())
        url = WirebAPI(action='newcase',
                  include_credentials=True,
                  wirebcode=wireb['fallcodenummer']).url()
        legendtext = "Wir.EB-Fallcodenummer anfordern und eintragen"
        wireb_anfordern_und_eintragen = h.FieldsetInputTable(
            legend='%s fr %s %s' % (legendtext, fall['akte__vn'], fall['akte__na']),
            daten = [[h.Link(text_before_link="Neuen Fall bei Wir.EB ber ",
                             string="diesen Link",
                             text_after_link=" anforden und besttigen lassen (Anmeldung erforderlich)",
                             url=url,
                             target='_blank',
                             tip="Anmeldung mit Benutzer: {} Passwort: {}" 
                             .format(config.WIREB_WEB_USER, config.WIREB_WEB_PASSWORD),
                             #class_='normaltext'
                             ),
                      h.TextItem(label='Fallcodenummer',
                                 name='fallcodenummer',
                                 value=wireb['fallcodenummer'],
                                 tip='Die von Wir.EB zugewiesene und besttigte Fallcodenummer hier eintragen',
                                 class_='textbox52',
                                 maxlength=5,
                                 ),
                      ],
                     ],
            )
        hidden = [("wirebid", wireb['id']),
                  ("fallid", fall['id']),
                  ("file", 'wirebeinf'),
                  ]
        res = h.FormPage(
            title="Wir.EB-Fallcodenummer anfordern und eintragen",
            name="wireb",
            action="klkarte",
            method="post",
            breadcrumbs = (('Hauptmen', 'menu'),
                           ('Klientenkarte', 'klkarte?akid=%(akte_id)s' % fall),
                           ),
            hidden=hidden,
            rows=(wireb_anfordern_und_eintragen,
                  h.SpeichernZuruecksetzenAbbrechen(),
                  )
            )
        return res.display()
    def _process_removewireb(self, REQUEST, RESPONSE, wireb):
        return h.SubmitOrBack(
            legend='Wir.EB-Anbindung lschen',
            action='klkarte',
            method='post',
            hidden=(('file', 'removewireb'),
                    ('wirebid', wireb['id']),
                    ),
            zeilen=("Soll die Anbindung dieses Falls an die Wir.EB Fallcodenummer '%s' gelscht werden?" % wireb['fallcodenummer'],
                    "",
                    "(Der Wir.EB-Fall mit seinen Evaluationsbgen bleibt erhalten, "
                    "nur die Verbindung zum EBKuS-Fall wird entfernt.)",
                    ),
            ).display()

    def reminder(self, wireb):
        """
        True, wenn der letzte Bogen vor mehr als sechs Monaten erstellt wurde,
        und noch kein Abschlussbogen erstellt wurde.
        """
        api = WirebAPI(action='remindersingle',
                  verbose=True,
                  include_credentials=True,
                  wirebcode=wireb['fallcodenummer'])
        res = api.run()
        if res.text == '1':
            return True
        return False

def get_empty_wireb_config_vars():
    if config.WIREB:
        return [kv.name for kv in config.iter() 
                if kv.name.startswith('wireb_') and not kv.value]
    else:
        return None

from ebkus.app.jghexport import JGHDatensatz

class WirebDatensatz(JGHDatensatz):
    """Erzeugt Datensatz im CSV-Format fr die automatisierte Abgabe bei Wir.EB.
    Zustzlich zu den Feldern der Jugendhilfestatistik die Wir.EB-spezifischen
    Felder.
    Ein WirebDatensatz muss fr jede Jugendhilfestatistik einzeln angelegt werden.
    self.wireb_csv_header()     liefert Headerzeile mit Attributen
    self.wireb_csv_datensatz()  liefert Datensatz mit Werten
    siehe:
    /home/atms/dev/ebkus/wir.eb/
       Anlage Dateiformat Statistikdaten 2019-02-14.pdf
    """
    # Diese Felder werden nicht in den Datensatz aufgenommen
    wireb_nicht_uebermitteln = (
        'KennNr',
        'AGSWohnortdesBeratenen',
        'PLZWohnortdesBeratenen',
        'WohnortdesBeratenen',
        'ZahlKinderAusserhalbFamilie',
        'RichtGenehm',
        'ZahlLeistungsstunden',
        'ZahlLeistungstage',
        'ZahlLeistungsstundenEnde',
        'ZahlLeistungstageEnde',
        )
    datensatz_info = JGHDatensatz.datensatz_info
    # Die Attributname fr die csv-Datei aus datensatz_info entnehmen
    wireb_namen = [name for _,name in sorted([(wireb_nr, name )for name, wireb_nr, _,_,_,_,_,_ in datensatz_info
                    if not(name is None or 
                           wireb_nr is None or 
                           name in wireb_nicht_uebermitteln)])]
    # Die zustzlichen Attribute fr Wir.EB
    wir_web_namen = [
      'WEBVersion',
      'WEBBeratungsstellennummer',
      'WEBFallcodenummer',
      'WEBGeschwisterLfd',
      'WEBFachsoftware',
      'WEBActioncode',
      ]

    def __init__(self, jgh, WEBFallcodenummer, WEBActioncode, **kw):
      super(WirebDatensatz, self).__init__(jgh)
      self.wir_daten = dict(WEBVersion=201901,
                            WEBBeratungsstellennummer=config.WIREB_BERATUNGSSTELLE,
                            WEBGeschwisterLfd=1,
                            WEBFachsoftware=config.WIREB_ANBIETER,
                            )
      self.wir_daten['WEBFallcodenummer'] = WEBFallcodenummer
      self.wir_daten['WEBActioncode'] = WEBActioncode
      for k, v in kw.items():
        if k in self.wir_daten:
          self.wir_daten[k] = v
    def get_csv_value(self, field, format, substitution, value):
        assert field is not None
        value = self.jgh[field]
        if substitution:
            res = substitution.get(value)
            if res is not None:
                return res
        assert value is not None
        if format:
            if format.endswith('d'):
                return value
            return format % value
        return value
    def wireb_csv_header(self):
        """Zeile mit Semikolon-getrennten Attributnamen"""
        return ';'.join(self.wireb_namen + self.wir_web_namen)
    def wireb_csv_datensatz(self):
        """Zeile mit Semikolon-getrennten Daten"""
        # dict: name --> wert
        res_dict = {}
        for name, wireb_nr, von, bis, field, format, substitution, value in self.datensatz_info:
            if name in self.wireb_namen:
                data = self.get_csv_value(field, format, substitution, value)
                res_dict[name] = data
        res_dict.update(self.wir_daten)
        daten_satz = ';'.join([str(res_dict[name]).strip() for name in self.wireb_namen + self.wir_web_namen])
        return daten_satz

class WirebAPI(object):
    """siehe:
    /home/atms/dev/ebkus/wir.eb/Anleitung Fallverlinkung 2019-10-30 EBKuS.pdf

    Benutzung:
    api = WirebAPI(<action>, <brige Parameter, sofern nicht schon per config bzw. default bekannt>)
    api.url()  -- liefert die entsprechende URL, die aber nicht aufgerufen wird.
    api.run()  -- fhrt die entsprechende action mit den angegeben Parametern aus (unter Verwendung
                  des Pythonmoduls requests) und liefert ein Response-Objekt r zurck:
                  r.status_code  -- Http-Antwortcode
                  r.text         -- Inhalt der Antwort
    api.csv(csv_datensatz) -- ldt Jugenhilfestatistikdatensatz hoch, der mit WirebDatensatz() 
                              erzeugt wurde.
    """
    # action --> Liste der notwendigen Parameter fr jede action
    action_params=dict(
        newcase=('anbieter',),
        newcaseurl=('anbieter',),
        codetoid=('wirebcode', 'beratungsstelle', 'return_'), # return_ muss durch return ersetzt werden beim Aufruf!
        reminderlist=('beratungsstelle',),
        remindersingle=('beratungsstelle','wirebcode'),
        )
    def __init__(self, action, **kw):
        try:
            import requests
            assert requests.__version__ == '2.3.0'
        except AttributeError:
            raise EE("Die Wir.EB-Funktionalitt erfordert eine neuere Version von Python 2.7."
                     "Installiert ist: {}, erforderlich ist mindestens 2.7.13".format(sys.version))
        self.requests = requests
        self.action = action
        defaults = dict(
            beratungsstelle=config.WIREB_BERATUNGSSTELLE,
            anbieter=config.WIREB_ANBIETER,
            user=config.WIREB_API_USER,
            password=config.WIREB_API_PASSWORD,
            regas=config.WIREB_API_ENDPOINT,
            regas_csv=config.WIREB_STATISTIK_IN_ENDPOINT,
            ssl=True,
            jahr=2017,
            andauernd=False,
            n=2,
            wirebcode=102,
            return_='id', # oder url, redirect
            include_credentials=False, # basic auth in die url
            verbose=False,
            )
        defaults.update(kw)
        for k,v in defaults.items():
            setattr(self, k, v)
        if self.regas[-1] != '/':
            self.regas += '/'
        if self.ssl:
            self.regas = self.regas.replace('http:/', 'https:/') 
            self.regas_csv = self.regas_csv.replace('http:/', 'https:/') 
    def test(self):
        print vars(self)
    def url(self):
        proto, rest = self.regas.split('//', 1)
        if self.include_credentials:
            user = urllib.quote(self.user, safe='')
            password = urllib.quote(self.password, safe='')
            url = "{proto}//{user}:{password}@{rest}?".format(**locals())
        else:
            url = self.regas + '?'
        param_list = ["{}={}".format(k,v) for k,v in self.get_params().items()]
        url += '&'.join(param_list)
        return url
    def get_params(self):
        params = dict([k, getattr(self, k)] for k in self.action_params[self.action])
        params['action'] = self.action
        if 'return_' in params: # hack wg. return/return_
            v = params['return_']
            params['return'] = v
            del params['return_']
        if self.verbose:
            print params
        return params
        
    def run(self):
        """Da die GET-actions strukturell gleich sind, machen wirs generisch."""
        r = self.requests.get(self.regas,
                              auth=(self.user, self.password),
                              params=self.get_params(),
                              )
        if self.verbose:
            print r.url
            print r.status_code
            print r.text
        return r
        
    def csv(self, csv_datensatz):
        if self.verbose:
            print csv_datensatz
        r = self.requests.post(self.regas_csv,
                               auth=(self.user, self.password),
                               headers={'Content-Type': 'application/octet-stream'},
                               data=csv_datensatz,
                               )
        if self.verbose:
            print r.url
            print r.status_code
        return r
  
# def falldauer(f):
#     j = f['jgh']
#     if not j:
#         return None
#     je = j.getDate('e')
#     b = f.getDate('bg')
#     return b.diff(je)
