# coding: latin-1

"""Utilities.

Sollten ohne EBKuS-Import auf oberster Ebene auskommen.
"""

import sys
import os
import time

def timeit(func, prompt, quiet=False, accu=None):
    def wrap(*args, **kwargs):
        started_at = time.time()
        result = func(*args, **kwargs)
        duration = time.time() - started_at
        if not quiet:
            print prompt, "%.3f" % (duration,)
        if accu:
            accu.add(duration, 
                     #func=func.func_name,
                     )
        return result
    return wrap


class Bunch(dict):
    """
    >>> b = Bunch()
    >>> b.myattr #doctest: +IGNORE_EXCEPTION_DETAIL
    Traceback (most recent call last):
    ...
    AttributeError:
    >>> b['myattr'] #doctest: +IGNORE_EXCEPTION_DETAIL
    Traceback (most recent call last):
    ...
    KeyError:
    >>> b.myattr = 3
    >>> b.myattr
    3
    >>> b['myattr']
    3
    >>> 'myattr' in b
    True
    """
    def __init__(self, *args, **kwds):
        super(Bunch, self).__init__(*args, **kwds)
        self.__dict__ = self

# Das funktioniert nicht
# class BunchNone(Bunch):
#     """
#     >>> b = BunchNone()
#     >>> b.myattr = 3
#     >>> b.myattr
#     3
#     >>> b['myattrpp']
#     >>> b.myattrpp
#     >>> b['myattr']
#     3
#     >>> b.myattr
#     3
#     >>> 
#     """
#     def __getattr__(self, attr):
#         #print 'GETATTR'
#         if attr in self.__dict__:
#             return  self.__dict__[attr]
#         return None
#     def __getitem__(self, key):
#         #print 'GETKEY'
#         if key in self.__dict__:
#             return  self.__dict__[key]
#         return None
# class BunchEmptyString(Bunch):
#     """
#     >>> b = BunchEmptyString()
#     >>> b.myattr
#     ''
#     >>> b['myattrpp']
#     ''
#     >>> b.myattr = 3
#     >>> b.myattr
#     3
#     >>> b['myattr']
#     3
#     """
#     def __getattribute__(self, attr):
#         #print 'GETATTR'
#         if attr in self.__dict__:
#             return  self.__dict__[attr]
#         return ''
#     def __getitem__(self, key):
#         #print 'GETKEY'
#         if key in self.__dict__:
#             return  self.__dict__[key]
#         return ''
    


if __name__ == '__main__':
    import doctest
    doctest.testmod()

    # >>> b.myattrpp = 3
    # >>> b['myattrpp']
    # 3
